#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_OnlineRewards.h"
std::auto_ptr<M_OnlineRewards> M_OnlineRewards::msSingleton(nullptr);

int M_OnlineRewards::GetCount()
{
	return (int)mMapData.size();
}

const M_OnlineRewardsData* M_OnlineRewards::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_OnlineRewardsData>& M_OnlineRewards::GetMapData()
{
	return mMapData;
}

void M_OnlineRewards::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_OnlineRewards.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_OnlineRewardsData data;
		data.mID = element->IntAttribute("ID");
		data.mTime = element->IntAttribute("Time");
		data.mGoldNumber = element->IntAttribute("GoldNumber");
		data.mPrimary = element->IntAttribute("Primary");
		data.mSenior = element->IntAttribute("Senior");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_OnlineRewards Loaded. Load Data:%u", mMapData.size());
}

void M_OnlineRewards::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_OnlineRewards");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_OnlineRewards");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_OnlineRewardsData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Time", data.mTime);
		LuaCfgHelper::readInt(L, "GoldNumber", data.mGoldNumber);
		LuaCfgHelper::readInt(L, "Primary", data.mPrimary);
		LuaCfgHelper::readInt(L, "Senior", data.mSenior);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_OnlineRewards Loaded. Load Data:%u", mMapData.size());
}

void M_OnlineRewards::Reload()
{
	mMapData.clear();
	Load();
}

M_OnlineRewards* M_OnlineRewards::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_OnlineRewards());
	}
	return msSingleton.get();
}

void M_OnlineRewards::Release()
{
	msSingleton.reset(nullptr);
}
